/****************************************************************************/
/* Sample for dbsct.c														*/
/****************************************************************************/
#pragma unpack
#pragma section C C$DSEC        // Section Name is C$DSEC
extern const struct {
    void *rom_s;   // Start address of the initialized data section in ROM
    void *rom_e;   // End   address of the initialized data section in ROM
    void *ram_s;   // Start address of the initialized data section in RAM
} _DTBL[] = {
    { __sectop("D"),   __secend("D"),   __sectop("R")   },
    { __sectop("D_2"), __secend("D_2"), __sectop("R_2") },
    { __sectop("D_1"), __secend("D_1"), __sectop("R_1") }
};
#pragma section C C$BSEC        // Section Name is C$DSEC
extern const struct {
    void *b_s;     // Start address of non-initialized data section
    void *b_e;     // End   address of non-initialized data section
} _BTBL[] = {
    { __sectop("B"),   __secend("B")   },
    { __sectop("B_2"), __secend("B_2") },
    { __sectop("B_1"), __secend("B_1") }
};
#pragma section
#pragma packoption