#include "iodefine.h"				// Peripheral Header File

// ===========================================
// n[h
void HardwareSetup(void)
{
	// NbNݒ					// NbN 12MHz
	SYSTEM.SCKCR.BIT.ICK = 0;		// VXeNbN x8 96MHz
	SYSTEM.SCKCR.BIT.PCK = 1;		// ӃW[NbN x4 48MHz
	SYSTEM.SCKCR.BIT.BCK = 1;		// OoXNbN/SDRAMNbN x4 48MHz
	
	SYSTEM.SCKCR.BIT.PSTOP0 = 1;	// SDCLK[qo͓ 0:Jn 1:~(HighŒ)
	SYSTEM.SCKCR.BIT.PSTOP1 = 1;	// BCLK[qo 0:Jn 1:~(HighŒ)
	PORT5.DDR.BIT.B3 = 1;			// BCLK[qo̓|[g
	SYSTEM.SCKCR.BIT.PSTOP1 = 0;	// BCLK[qo 0:Jn 1:~(HighŒ)

// FRK-RX62N + LFCQ1 }bv
// CS	 A21`A0			P61(A22p)
// ---------------------------------------------------------
// 2 0x06 000000 - 3FFFFF	0		// SRAM
// ---------------------------------------------------------
// 3 0x05 000000 - 0FFFFF	0		// PC/104 8bit 
// 3 0x05 100000 - 10FFFF	0		// PC/104 8bit I/O
// ---------------------------------------------------------
// 4 0x04 000000 - 1FFFFF	1		// PC/104 16bit 
// 4 0x04 200000 - 20FFFF	1		// PC/104 16bit I/O
// 4 0x04 300000 - 300FFF	1		// LF-A1
// ---------------------------------------------------------
// LFCQ1 CPLD ̂܂܎gpׂɁASH2AA22ƂĎgps RX62Nł I/O sŐ䂷
// SH2A Ƃ̑
// LFCQ1	SH2A		RX62N		
// CN2 33	CS3			CS2(A22)	
// CN2 34	A22(CS4)	PC7(CS1/A23)

//	 FRK-RX62N + LFCQ1 pݒ ===================
	
	// `bvZNgݒ
	IOPORT.PF0CSE.BIT.CS1E = 0;		// CS1o͖ P61(A22p)ƂĎgp
	PORT6.DDR.BIT.B1 = 1;			// P61(A22p)o̓|[g
	PORT6.DR.BIT.B1 = 0;			// P61(A22p)Lowo
	IOPORT.PF0CSE.BIT.CS2E = 1;		// CS2o͗L SRAM
	IOPORT.PF0CSE.BIT.CS3E = 1;		// CS3o͗L PC/104-8bit
	IOPORT.PF0CSE.BIT.CS4E = 1;		// CS4o͗L PC/104-16bit, LFA1
	IOPORT.PF2CSS.BIT.CS2S = 0;		// P62CS2o͒[qƂĎgp
	IOPORT.PF2CSS.BIT.CS3S = 0;		// P63CS3o͒[qƂĎgp
	IOPORT.PF1CSS.BIT.CS4S = 0;		// P64CS4o͒[qƂĎgp
	// |[g@\ݒ
	IOPORT.PF4BUS.BIT.ADRLE = 3;	// A0`A9o͗L
	IOPORT.PF4BUS.BIT.A10E = 1;		// A10o͗L
	IOPORT.PF4BUS.BIT.A11E = 1;		// A11o͗L
	IOPORT.PF4BUS.BIT.A12E = 1;		// A12o͗L
	IOPORT.PF4BUS.BIT.A13E = 1;		// A13o͗L
	IOPORT.PF4BUS.BIT.A14E = 1;		// A14o͗L
	IOPORT.PF4BUS.BIT.A15E = 1;		// A15o͗L
	IOPORT.PF3BUS.BIT.A16E = 1;		// A16o͗L
	IOPORT.PF3BUS.BIT.A17E = 1;		// A17o͗L
	IOPORT.PF3BUS.BIT.A18E = 1;		// A18o͗L
	IOPORT.PF3BUS.BIT.A19E = 1;		// A19o͗L
	IOPORT.PF3BUS.BIT.A20E = 1;		// A20o͗L
	IOPORT.PF3BUS.BIT.A21E = 1;		// A21o͗L
	IOPORT.PF3BUS.BIT.A22E = 0;		// A22o͖
	IOPORT.PF3BUS.BIT.A23E = 0;		// A23o͖
	IOPORT.PF5BUS.BIT.ADRHMS = 1;	// P90`P93A16`A19AhXoXƂĎgp
	IOPORT.PF5BUS.BIT.DHE = 1;		// PE0`PE7D8`D15f[^oXƂĎgp
	IOPORT.PF5BUS.BIT.WR1BC1E = 1;	// P51WR1ƂĎgp
	IOPORT.PF6BUS.BIT.WAITS = 3;	// P55WAIT͒[qƂĎgp
	// OoXRg[(CS2) SRAM
	BSC.CS2CR.BIT.EXENB = 1;		// CS2
	BSC.CS2CR.BIT.BSIZE = 0;		// 16rbgoX
	BSC.CS2CR.BIT.EMODE = 0;		// 샂[hGfBAƓ
	BSC.CS2MOD.BIT.WRMOD = 0;		// oCgXg[u[h
	BSC.CS2MOD.BIT.EWENB = 0;		// OEGCg֎~
	BSC.CS2WCR1.BIT.CSWWAIT = 2;	// m[}CgTCN4EFCg 0`31
	BSC.CS2WCR1.BIT.CSRWAIT = 2;	// m[}[hTCN4EFCg 0`31
	BSC.CS2WCR2.BIT.CSROFF = 0;		// [hCSTCN 0`7
	BSC.CS2WCR2.BIT.CSWOFF = 0;		// CgCSTCN 0`7
	BSC.CS2WCR2.BIT.WDOFF = 0;		// Cgf[^o͉TCN 0`7
	BSC.CS2WCR2.BIT.RDON = 0;		// RDAT[gEGCg 0`7
	BSC.CS2WCR2.BIT.WRON = 0;		// WRAT[gEGCg 0`7
	BSC.CS2WCR2.BIT.WDON = 0;		// Cgf[^o̓EGCg 0`7
	BSC.CS2WCR2.BIT.CSON = 0;		// CSAT[gEGCg 0`7
	BSC.CS2REC.BIT.RRCV = 0;		// [hJoTCN 0`15
	BSC.CS2REC.BIT.WRCV = 0;		// CgJoTCN 0`15
	// OoXRg[(CS3) PC/104-8bit
	BSC.CS3CR.BIT.EXENB = 1;		// CS3
	BSC.CS3CR.BIT.BSIZE = 2;		// 8rbgoX
	BSC.CS3CR.BIT.EMODE = 0;		// 샂[hGfBAƓ
	BSC.CS3MOD.BIT.WRMOD = 0;		// oCgXg[u[h
	BSC.CS3MOD.BIT.EWENB = 0;		// OEGCg֎~
	BSC.CS3WCR1.BIT.CSWWAIT = 31;	// m[}CgTCN 0`31
	BSC.CS3WCR1.BIT.CSRWAIT = 31;	// m[}[hTCN 0`31
	BSC.CS3WCR2.BIT.CSROFF = 7;		// [hCSTCN 0`7
	BSC.CS3WCR2.BIT.CSWOFF = 7;		// CgCSTCN 0`7
	BSC.CS3WCR2.BIT.WDOFF = 7;		// Cgf[^o͉TCN 0`7
	BSC.CS3WCR2.BIT.RDON = 7;		// RDAT[gEGCg 0`7
	BSC.CS3WCR2.BIT.WRON = 7;		// WRAT[gEGCg 0`7
	BSC.CS3WCR2.BIT.WDON = 7;		// Cgf[^o̓EGCg 0`7
	BSC.CS3WCR2.BIT.CSON = 7;		// CSAT[gEGCg 0`7
	BSC.CS3REC.BIT.RRCV = 15;		// [hJoTCN 0`15
	BSC.CS3REC.BIT.WRCV = 15;		// CgJoTCN 0`15
	// OoXRg[(CS4) PC/104-16bit
	BSC.CS4CR.BIT.EXENB = 1;		// CS4
	BSC.CS4CR.BIT.BSIZE = 0;		// 16rbgoX
	BSC.CS4CR.BIT.EMODE = 0;		// 샂[hGfBAƓ
	BSC.CS4MOD.BIT.WRMOD = 0;		// oCgXg[u[h
	BSC.CS4MOD.BIT.EWENB = 0;		// OEGCg֎~
	BSC.CS4WCR1.BIT.CSWWAIT = 31;	// m[}CgTCNEGCg 0`31
	BSC.CS4WCR1.BIT.CSRWAIT = 31;	// m[}[hTCNEFCg 0`31
	BSC.CS4WCR2.BIT.CSROFF = 7;		// [hCSTCN 0`7
	BSC.CS4WCR2.BIT.CSWOFF = 7;		// CgCSTCN 0`7
	BSC.CS4WCR2.BIT.WDOFF = 7;		// Cgf[^o͉TCN 0`7
	BSC.CS4WCR2.BIT.RDON = 7;		// RDAT[gEGCg 0`7
	BSC.CS4WCR2.BIT.WRON = 7;		// WRAT[gEGCg 0`7
	BSC.CS4WCR2.BIT.WDON = 7;		// Cgf[^o̓EGCg 0`7
	BSC.CS4WCR2.BIT.CSON = 7;		// CSAT[gEGCg 0`7
	BSC.CS4REC.BIT.RRCV = 15;		// [hJoTCN 0`15
	BSC.CS4REC.BIT.WRCV = 15;		// CgJoTCN 0`15
	// OoXLݒ
	SYSTEM.SYSCR0.WORD = 0x5A03;	// Cg擪0x5A b1:OoXL b0:ROML
	
	PORT1.DDR.BIT.B5 = 1;			// P15o̓|[g FRK-RX62N LED1
	PORT1.DR.BIT.B5 = 1;			// FRK-RX62N LED1 
	PORT1.DR.BIT.B5 = 0;			// FRK-RX62N LED1 _
}
