// ===========================================
// FRK-RX62N OoXANZX

#include "global.h"							// ʒ`

static int timer_f = 0;						// ^C}tO
static int intr_f = 0;						// ADC荞݃tO


// ===========================================
// PC/104oX 
void irq_init(void)
{
	// ---------------------------------------
	// PC/104-IRQ7 = RX62N-IRQ10(P02)
	IEN( ICU, IRQ10 ) = 0;					// ݋֎~
	PORT0.ICR.BIT.B2 = 1;					// ̓obt@L(K{)
	ICU.IRQCR[10].BIT.IRQMD = 1;			// GbW
	IPR( ICU, IRQ10 ) = 1;					// ݃x
	IEN( ICU, IRQ10 ) = 1;					// ݋
	// ---------------------------------------
	// PC104-IRQ11 = RX62N-IRQ11(P03)
	IEN( ICU, IRQ11 ) = 0;					// ݋֎~
	PORT0.ICR.BIT.B3 = 1;					// ̓obt@L(K{)
	ICU.IRQCR[11].BIT.IRQMD = 1;			// GbW
	IPR( ICU, IRQ11 ) = 1;					// ݃x
	IEN( ICU, IRQ11 ) = 1;					// ݋
}
// ===========================================
// PC/104oX IRQ7 
// LFCQ1 CN2-31 ɑΉ (RX62Nł IRQ10)
#pragma interrupt IntPC104IRQ7(vect=VECT(ICU, IRQ10), enable)
void IntPC104IRQ7(void)
{
	disp("PC/104 IRQ7 !\r\n");
	intr_adc_pro();							// ADϊf[^8chǂݏo
	intr_f = 1;
}
// ===========================================
// PC/104oX IRQ11 
// LFCQ1 CN2-32 ɑΉ (RX62Nł IRQ11)
#pragma interrupt IntPC104IRQ11(vect=VECT(ICU, IRQ11), enable)
void IntPC104IRQ11(void)
{
	disp("PC/104 IRQ11 !\r\n");
}


// ===========================================
// ^C}
void timer_init(void)
{
	MSTP( CMT0 ) = 0;						// CMT0/1 X^oC
	// ---------------------------------------
	// CMT0
	CMT.CMSTR0.BIT.STR0 = 0;				// JEg~
	CMT0.CMCOR = ((PCLK / 512) / 2) - 1;	// RyA}b`WX^ 500ms
	CMT0.CMCR.BIT.CKS = 3;					// NbNI 0:PCLK/8 1:/32 2:/128 3:/512
	CMT0.CMCR.BIT.CMIE = 1;					// ݋
	IPR( CMT0, CMI0 ) = 1;					// ݃x
	IEN( CMT0, CMI0 ) = 1;					// ݋
	CMT.CMSTR0.BIT.STR0 = 1;				// JEgJn
	// ---------------------------------------
	// CMT1
	CMT.CMSTR0.BIT.STR1 = 0;				// JEg~
	CMT1.CMCOR = ((PCLK / 8) / 1000) - 1;	// RyA}b`WX^ 1ms
	CMT1.CMCR.BIT.CKS = 0;					// NbNI 0:PCLK/8 1:/32 2:/128 3:/512
	CMT1.CMCR.BIT.CMIE = 1;					// ݋
	IPR( CMT1, CMI1 ) = 1;					// ݃x
	IEN( CMT1, CMI1 ) = 1;					// ݋
	CMT.CMSTR0.BIT.STR1 = 1;				// JEgJn
}
// ===========================================
// CMT0  500ms
#pragma interrupt IntCMI0(vect=VECT(CMT0, CMI0), enable)
void IntCMI0(void)
{
	LED_REV();								// LED]
}
// ===========================================
// CMT1  1ms
#pragma interrupt IntCMI1(vect=VECT(CMT1, CMI1), enable)
void IntCMI1(void)
{
	timer_f = 1;							// ^C}tOZbg
}


// ===========================================
// wv\
void help_disp(void)
{
	disp("\r\n");
	disp("y eXgR}hꗗ z\r\n");
	disp("MT I                : LFCQ1 [JeXg 0x6000000-0x63fffff\r\n");
	disp("MT E                : PC/104 ̈eXg 0x4000000-0x40fffff\r\n");
	disp("AI                  : PC/104 I/Ö ADCϊ荞 IRQ7\r\n");
	disp("AO 0/1              : PC/104 I/Ö DACϊ~/Jn\r\n");
	disp("GET B/W/L adrs data : ANZXPʃAhXw胊[h\r\n");
	disp("SET B/W/L adrs data : ANZXPʃAhXw胉Cg\r\n");
	disp("R}hꗗ : HELP\r\n");
	disp("\r\n");
}
// ===========================================
// R}hG[
void command_err(void)
{
	disp("NG\r\n");							// vvg
}
// ===========================================
// R}h^XN
void command_tsk(void)
{
	char *p;								// R}h|C^
	char cmd[16];							// R}h
	static char str[2][16];						// R}hp[^
	static unsigned long lp[3];					// unsigend long p[^
//	int pc;									// p[^
	
	if(p = inkey())							// R}h(啶̂)
	{
		sscanf(p, "%s", cmd);				// R}h񒊏o
		switch(cmd[0])
		{
		case 'A':							// A`
			if(!strcmp(cmd, "AI"))			// 
			{
				adm612_sampstart();			// ADCTvOJn
			//	adm612_once();				// _~[ϊ
			//	intr_f = 1;					// ADC荞݃tO
			}
			else if(!strcmp(cmd, "AO"))
			{
				sscanf(p, "%s %s %lx %lx", str[0], str[1]);	// R}h񒊏o
				if(str[1][0] == '1')
				{
					IEN( CMT1, CMI1 ) = 1;	// ݋
				}
				else
				{
					IEN( CMT1, CMI1 ) = 0;	// ݋֎~
				}
			}
			else command_err();
			break;
		case 'G':							// G`
			if(!strcmp(cmd, "GET"))				// [h
			{									// oCg:SET B adrs data / [h:SET W adrs data / O:SET L adrs data
				sscanf(p, "%s %s %lx %lx", str[0], str[1], &lp[0], &lp[1]);	// R}h񒊏o
				switch(lp[0] >> 24)
				{
				case 0x06:	// SRAM
					A22 = 0;
					break;				
				case 0x05:	// PC/104-8bit
					A22 = 0;
					break;
				case 0x04:	// PC/104-16bit
					A22 = 1;
					break;
				}
				switch(str[1][0])
				{
				case 'B':
					lp[1] = *(unsigned char *)lp[0];
					disp("0x%02lX <- *(unsigned char *)0x%08lX\r\n", lp[1], lp[0]);
					break;
				case 'W':
					lp[1] = *(unsigned short *)lp[0];
					disp("0x%04lX <- *(unsigned short *)0x%08lX\r\n", lp[1], lp[0]);
					break;
				case 'L':
					lp[1] = *(unsigned long *)lp[0];
					disp("0x%08lX <- *(unsigned long *)0x%08lX\r\n", lp[1], lp[0]);
					break;
				}
			}
			else command_err();
			break;
		case 'H':							// H`
			if(!strcmp(cmd, "HELP"))		// HELP
			{
				help_disp();				// wv\
			}
			else command_err();
			break;
		case 'M':							// M`
			if(!strcmp(cmd, "MT"))			// eXg
			{
				sscanf(p, "%s %s %s", str[0], str[1], str[2]);	// R}h񒊏o
				if(str[1][0] == 'E')		// PC/104 ̈
				{
					A22 = 1;
					if(memtest(0x04000000L, 0x040fffffL) != 0)
					{
						disp("Error Stop ...\r\n");
					}
				}
				else if(str[1][0] == 'I')	// LFCQ1 [J
				{
					A22 = 0;
					if(memtest(0x06000000L, 0x063fffffL) != 0)
					{
						disp("Error Stop ...\r\n");
					}
				}
			}			
			case 'S':							// S`
			if(!strcmp(cmd, "SET"))				// Cg
			{									// oCg:SET B adrs data / [h:SET W adrs data / O:SET L adrs data
				sscanf(p, "%s %s %lx %lx", str[0], str[1], &lp[0], &lp[1]);	// R}h񒊏o
				switch(lp[0] >> 24)
				{
				case 0x06:	// SRAM
					A22 = 0;
					break;				
				case 0x05:	// PC/104-8bit
					A22 = 0;
					break;
				case 0x04:	// PC/104-16bit
					A22 = 1;
					break;
				}
				switch(str[1][0])
				{
				case 'B':
					*(volatile unsigned char *)lp[0] = (unsigned char)lp[1];
					disp("*(unsigned char *)0x%08lX <- 0x%02X\r\n", lp[0], (unsigned char)lp[1]);
					break;
				case 'W':
					*(volatile unsigned short *)lp[0] = (unsigned short)lp[1];
					disp("*(unsigned short *)0x%08lX <- 0x%04X\r\n", lp[0], (unsigned short)lp[1]);
					break;
				case 'L':
					*(volatile unsigned long *)lp[0] = lp[1];
					disp("*(unsigned long *)0x%08lX <- 0x%08lX\r\n", lp[0], lp[1]);
					break;
				}
			}
			else command_err();
			break;
		default:
			command_err();
			break;
		}
	}
}


// ===========================================
// C
void main(void)
{
	timer_init();							// ^C}
	irq_init();								// PC/104oX荞ݏ
	sci2_init( 38400, 8, 1, 0 );			// ^[~ipSCI
	A22 = 0;								// ̈ؑ
	dac12_init( 0x05100000 );				// PC/104-8bitI/Ö 2ch12bitDAC
	adm612_init( 0x05100000 );				// PC/104-8bitI/Ö 8ch12bitADC
	A22 = 1;								// ̈ؑ
	lf70_init( 0x04200000 );				// PC/104-16bitI/Ö 32ch12bitDAC
	set_psw( 0x00010000 );					// Set I=1, IPL=0 of PSW

	disp("\r\nFRK-RX62N OoXANZX Ver1.00\r\n");
	help_disp();							// wv\
	timer_f = 0;							// ^C}tO
	intr_f = 0;								// ADC荞݃tO
	while(1)
	{
		command_tsk();						// R}h^XN
		
		if(timer_f)							// 1ms荞݃tO
		{
			timer_f = 0;					// ^C}tOZbg
			
			A22 = 0;
			dac12_tsk();					// MPC104-DAC12 DAC SINgo
			A22 = 1;
			lf70_tsk();						// LF70 DAC SINgo
		}
		
		if(intr_f)							// ADC荞݃tO
		{
			intr_f = 0;						// ADC荞݃tOZbg
			
			disp("\r\n1:%03X 2:%03X 3:%03X 4:%03X 5:%03X 6:%03X 7:%03X 8:%03X\r\n"
			, ad_data[0], ad_data[1], ad_data[2], ad_data[3]
			, ad_data[4], ad_data[5], ad_data[6], ad_data[7]);
		}
	}
}
