/************************************************************************/
/* Sample for vecttbl.c													*/
/************************************************************************/
#include "vect.h"
#ifdef COEXISTENCE
#pragma interrupt Coexistence(vect=8)
void Coexistence(void)
{
	PowerON_Reset( );
}
#else
#pragma section C FIXEDVECT
#ifndef DEBUG
void (* const Fixed_Vectors[])(void) = {
    Dummy,			// 0xffffff80  Reserved
    Dummy,			// 0xffffff84  Reserved
    Dummy,			// 0xffffff88  Reserved
    Dummy,			// 0xffffff8c  Reserved
    Dummy,			// 0xffffff90  Reserved
    Dummy,			// 0xffffff94  Reserved
    Dummy,			// 0xffffff98  Reserved
    Dummy,			// 0xffffff9c  Reserved
    Dummy,			// 0xffffffa0  Reserved
    Dummy,			// 0xffffffa4  Reserved
    Dummy,			// 0xffffffa8  Reserved
    Dummy,			// 0xffffffac  Reserved
    Dummy,			// 0xffffffb0  Reserved
    Dummy,			// 0xffffffb4  Reserved
    Dummy,			// 0xffffffb8  Reserved
    Dummy,			// 0xffffffbc  Reserved
    Dummy,			// 0xffffffc0  Reserved
    Dummy,			// 0xffffffc4  Reserved
    Dummy,			// 0xffffffc8  Reserved
    Dummy,			// 0xffffffcc  Reserved
    Dummy,			// 0xffffffd0  Exception(Supervisor Instruction)
    Dummy,			// 0xffffffd4  Reserved
    Dummy,			// 0xffffffd8  Reserved
    Dummy,			// 0xffffffdc  Exception(Undefined Instruction)
    Dummy,			// 0xffffffe0  Reserved
    Dummy,			// 0xffffffe4  Exception(Floating Point)
    Dummy,			// 0xffffffe8  Reserved
    Dummy,			// 0xffffffec  Reserved
    Dummy,			// 0xfffffff0  Reserved
    Dummy,			// 0xfffffff4  Reserved
    NMI,			// 0xfffffff8  NMI
	PowerON_Reset	// 0xfffffffc  RESET
};
#else
void (* const Fixed_Vectors[])(void) = {
	PowerON_Reset,
	(void (*)(void))__secend("SI")
};
#endif
#endif