// ===========================================
// FRK-SH2A OoXANZX

#include "global.h"							// ʒ`

static int timer_f = 0;						// ^C}tO
static int intr_f = 0;						// ADC荞݃tO


// ===========================================
// PC/104oX 
void irq_init(void)
{
	// ---------------------------------------
	// PC/104-IRQ7 = SH2A-IRQ2
	INTC.ICR1.BIT.IRQ21S = 0;		// IRQ2荞ݗvGbW
	INTC.ICR1.BIT.IRQ20S = 1;		// IRQ2荞ݗvGbW
	INTC.IPR01.BIT._IRQ2 = 1;		// IRQ2荞݃x = 1
	
	// ---------------------------------------
	// PC104-IRQ11 = SA2A-IRQ3
	INTC.ICR1.BIT.IRQ31S = 0;		// IRQ3荞ݗvGbW
	INTC.ICR1.BIT.IRQ30S = 1;		// IRQ3荞ݗvGbW
	INTC.IPR01.BIT._IRQ3 = 1;		// IRQ3荞݃x = 1
}
// ===========================================
// PC/104oX IRQ7 
// LFCQ1 CN2-31 ɑΉ (SH2A ł IRQ2)
void IntPC104IRQ7(void)
{
	intr_adc_pro();							// ADϊf[^8chǂݏo
	intr_f = 1;
	disp("PC/104 IRQ7 !\r\n");
}
// ===========================================
// PC/104oX IRQ11 
// LFCQ1 CN2-32 ɑΉ (SH2A ł IRQ3)
void IntPC104IRQ11(void)
{
	disp("PC/104 IRQ11 !\r\n");
}


// ===========================================
// ^C}
void timer_init(void)
{
	CPG.STBCR7.BIT.MSTP72 = 0;				// RyA}b`^C}Jn
	// ---------------------------------------
	// CMT0
	CMT.CMSTR.BIT.STR0 = 0;					// JEg~
	CMT.CMCOR0.WORD = ((PCLK / 512) / 2) - 1;	// RyA}b`WX^ 500ms
	CMT.CMCSR0.BIT.CKS = 3;					// NbNI 0:PCLK/8 1:/32 2:/128 3:/512
	INTC.IPR10.BIT._CMT0 = 1;				// 荞݃x
	CMT.CMCSR0.BIT.CMF = 0;					// RyA}b`tONA
	CMT.CMCSR0.BIT.CMIE = 1;				// RyA}b`荞݋
	CMT.CMSTR.BIT.STR0 = 1;					// JEgJn
	// ---------------------------------------
	// CMT1
	CMT.CMSTR.BIT.STR1 = 0;					// JEg~
	CMT.CMCOR1.WORD = ((PCLK / 8) / 1000) - 1;	// RyA}b`WX^ 1ms
	CMT.CMCSR1.BIT.CKS = 0;					// NbNI 0:PCLK/8 1:/32 2:/128 3:/512
	INTC.IPR10.BIT._CMT1 = 1;				// 荞݃x
	CMT.CMCSR1.BIT.CMF = 0;					// RyA}b`tONA
	CMT.CMCSR1.BIT.CMIE = 1;				// RyA}b`荞݋
	CMT.CMSTR.BIT.STR1 = 1;					// JEgJn
}
// ===========================================
// CMT0  500ms
void IntCMI0(void)
{
	CMT.CMCSR0.BIT.CMF = 0;					// RyA}b`tONA
	
	LED_REV();								// LED]
}
// ===========================================
// CMT1  1ms
void IntCMI1(void)
{
	CMT.CMCSR1.BIT.CMF = 0;					// RyA}b`tONA
	
	timer_f = 1;							// ^C}tOZbg
}


// ===========================================
// wv\
void help_disp(void)
{
	disp("\r\n");
	disp("y eXgR}hꗗ z\r\n");
	disp("MT I         : LFCQ1 [JeXg 0x6000000-0x63fffff\r\n");
	disp("MT E         : PC/104 ̈eXg 0x4000000-0x40fffff\r\n");
	disp("AI           : PC/104 I/Ö ADCϊ荞 IRQ7\r\n");
	disp("R}hꗗ : HELP\r\n");
	disp("\r\n");
}
// ===========================================
// R}hG[
void command_err(void)
{
	disp("NG\r\n");							// vvg
}
// ===========================================
// R}h^XN
void command_tsk(void)
{
	char *p;								// R}h|C^
	char str[3][16];						// R}hp[^
//	int pc;									// p[^
	
	if(p = inkey())							// R}h(啶̂)
	{
		sscanf(p, "%s %s %s", str[0], str[1], str[2]);	// R}h񒊏o
		switch(str[0][0])
		{
		case 'A':							// A`
			if(!strcmp(str[0], "AI"))		// 
			{
				adm612_sampstart();			// ADCTvOJn
			}
			else command_err();
			break;
		case 'H':							// H`
			if(!strcmp(str[0], "HELP"))		// HELP
			{
				help_disp();				// wv\
			}
			else command_err();
			break;
		case 'M':							// M`
			if(!strcmp(str[0], "MT"))		// eXg
			{
				if(!strcmp(str[1], "E"))	// PC/104 ̈
				{
					if(memtest(0x20400000, 0x204fffff) != 0)
					{
						disp("Error Stop ...\r\n");
					}
				}
				else if(!strcmp(str[1], "I"))	// LFCQ1 [J
				{
					if(memtest(0x2c000000, 0x2c3fffff) != 0)
					{
						disp("Error Stop ...\r\n");
					}
				}
			}
			else command_err();
			break;
		default:
			command_err();
			break;
		}
	}
}


// ===========================================
// C
void main(void)
{
	timer_init();							// ^C}
	irq_init();								// PC/104oX荞ݏ
	sci3_init( 38400, 8, 1, 0);				// ^[~ipSCI
	dac12_init( 0x38100000 );				// PC/104-8bitI/Ö 2ch12bitDAC
	adm612_init( 0x38100000 );				// PC/104-8bitI/Ö 8ch12bitADC
	lf70_init( 0x20600000 );				// PC/104-16bitI/Ö 32ch12bitDAC
	set_imask(0);							// 荞݋
	
	disp("\r\nFRK-RX62N OoXANZX Ver1.00\r\n");
	help_disp();							// wv\
	timer_f = 0;							// ^C}tO
	intr_f = 0;								// ADC荞݃tO
	while(1)
	{
		command_tsk();						// R}h^XN
		
		if(timer_f)							// 1ms荞݃tO
		{
			timer_f = 0;					// ^C}tOZbg
			
			dac12_tsk();					// LF70 DAC SINgo
			lf70_tsk();						// MPC104-DAC12 DAC SINgo
		}
		
		if(intr_f)							// ADC荞݃tO
		{
			intr_f = 0;						// ADC荞݃tOZbg
			
			disp("\r\n1:%03X 2:%03X 3:%03X 4:%03X 5:%03X 6:%03X 7:%03X 8:%03X\r\n"
			, ad_data[0], ad_data[1], ad_data[2], ad_data[3]
			, ad_data[4], ad_data[5], ad_data[6], ad_data[7]);
		}
	}
}
