// =========================================== 
// LF70 PC/104-16bit I/O
// =========================================== 

#include <math.h>							// SIN ŕKv
#include "PC104_DAC16.h"

//#define LF70BASE	0x04200000				// FRK-RX62N + LFCQ1 PC/104 16bit I/OGA 擪AhX(Œ)
#define LF70OFFS	0x00					// LF70 ItZbg(A15-A8)
#define lf70_set(c)	*((volatile unsigned short *)(LF70BASE + LF70OFFS + c))	// DACWX^ANZX

static unsigned long LF70BASE;				// FRK-RX62N + LFCQ1 PC/104 16bit I/OGA 擪AhX(Œ)
static int lf70_ladrs;						// b`AhX

// ===========================================
// DAC 16bitoXݒ
void lf70_init(
	unsigned long ba)						// x[XAhX
{
	int c;									// JE^
	
	LF70BASE = ba;							// x[XAhXύX\Ƃ
	
	// --------------------------------------- {[hݒ
	lf70_set(0x36) = 0;						// CPLDZbg(f[^͔C)
	lf70_set(0x32) = 0x0002;				// n[hEFAt@NVݒ
//	D4 D3 D2 D1 D0
//	|  |  |  |  |
//	|  |  |  |  +-------gO[hWX^	0:A		1:B
//	|  |  |  +----------CLR(lowGbWgK)	0:EXE	1:STB
//	|  |  +-------------FIFO				0:DIS	1:ENB
//	|  +----------------p[_E			0:DIS	1:ENB
//	+-------------------rW[(READ ONLY)		0:BUSY	1:RADY
	
	lf70_set(0x1e) = 0;						// DAC\tgEFAZbg(f[^͔C)
	for(c = 0; c < 30000; c++)				// Zbg̃rW[`FbN
	{
		if(lf70_set(0x32) & 0x0010)			// n[hEFAt@NVݒ胊[h
		{	//nBUSY=1Ȃ甲
			break;
		}
	}
	
	lf70_set(0x18) = 0x0700;				// Rg[WX^ݒ(REF,BoostON,2.5v)
	lf70_ladrs = 0xff;
	lf70_set(0x30) = lf70_ladrs;			// o͍XVAhX(A15-A4)ݒ
	lf70_ladrs <<= 4;
	// ݒl000H`FFFH͈̔́AhXA15-A4(000*H`FFF*H)͈̔͂ƂȂ܂B*͔Cӂ̒l
	
	// --------------------------------------- QC/ItZbg/o͓dlݒ
	for(c = 0; c <= 31; c++)				// `l
	{										// JԂ
		lf70_set(0x40 + (c << 1)) = 0x0ffe;	// QC
		lf70_set(0x80 + (c << 1)) = 0x0800;	// ItZbg
		lf70_set(0xc0 + (c << 1)) = 0x07ff;	// o͓d
	}
	lf70_set(lf70_ladrs) = 0;				// SDAC o͍XV
}

// ===========================================
// DACeXgŃTCg`o
// e`l45xÂʑ炵Ă܂
#ifndef PI
#define PI 3.141592654						// ~
#endif
#ifndef DEG_RAD
#define DEG_RAD(Q) ((Q)*PI/180)				// x>WAϊ
#endif
#ifndef RAD_DEG
#define RAD_DEG(Q) ((Q)/PI*180)				// WA>xϊ
#endif
void lf70_tsk(void)
{	
	static int seq = 0;						// V[PX
	static int sind[] = {
		  0, 10, 20, 30, 40, 50, 60, 70,
		 80, 90,100,110,120,130,140,150,
		160,170,180,190,200,210,220,230,
		240,250,260,270,280,290,300,310};	// px
	static unsigned short sin_tbl[360];		// TCge[u
	int c;									// JE^
	
	switch(seq)
	{
	case 0:									// TCge[u
		for(c = 0; c <= 359; c++)
		{
			sin_tbl[c] = (unsigned short)((sin(DEG_RAD(c)) + 1) * 0x7ff);
		}
		seq++;
		break;
	case 1:
		for(c = 0; c <= 31; c++)
		{
			lf70_set(0xc0 + (c << 1)) = sin_tbl[sind[c]];	// o̓f[^Zbg
			if(sind[c] < 359)
			{
				sind[c]++;
			}
			else
			{
				sind[c] = 0;
			}
		}
		lf70_set(lf70_ladrs) = 0;			// SDAC o͍XV
		break;
	}
}