// ===========================================
// ADM-612PC104

#include "PC104_ADC8.h"

//#define ADC612BASE	0x28100000			// LFCQ1 PC/104 8bit I/OGA 擪AhX(Œ)
#define ADC612OFFS	0x1d0					// ADM-612PC104 ItZbg o׎AhX(SW1`3 ŕύX\)
//#define ADC612ADRS	(volatile unsigned char *)(ADC612BASE + ADC612OFFS)
#define ADMINTCLK	20000000L				// NbN(Hz)

volatile unsigned char *ADC612ADRS;			// x[XAhX

int ad_data[8];								// ϊf[^
unsigned char adc_stus;						// ADCXe[^X

// ===========================================
// NbNݒ
void adm612_setprs(
	unsigned long prs)						// (ő0xffffffff)
{
	int c;									// JE^
	for(c = 0; c <= 3; c++)
	{
		*(ADC612ADRS + 0x04) = (unsigned char)(prs & 0x000000ff);
		prs >>= 8;							// 1byteړ
	}
}

// ===========================================
// TvO񐔐ݒ
void adm612_setcunt(						// TvO񐔐ݒ
	unsigned long cunt)						// TvO(ő0xffffffff)
{
	int c;									// JE^
	for(c = 0; c <= 3; c++)
	{
		*(ADC612ADRS + 0x05) = (unsigned char)(cunt & 0x000000ff);
		cunt >>= 8;							// 1byteړ
	}
}

// ===========================================
// ̂݃TvOJn
int *adm612_once(void)
{
	static int ad[8];
	int ch;
	
	ch = *(ADC612ADRS + 0x0a);		// ϊJn
	while(*(ADC612ADRS + 0x0c) & 0x04 != 0x04);	// TvOIH
	*(ADC612ADRS + 0x0c) = 0x40;			// EOStOZbg
	for(ch = 0; ch <= 7; ch++)				// Ǐo
	{
		ad[ch] = *(ADC612ADRS + 0x00) << 8;	// 
		ad[ch] |= *(ADC612ADRS + 0x00);		// 
	}
	return ad;
}

// ===========================================
// 1TvO邽тɊ荞݂𔭐
// w񐔂IăX^[g
// TvOJn
void adm612_sampstart(void)	
{
	adm612_setcunt(0x00000001);				// TvO񐔐ݒ ([h͖̎)
	*(ADC612ADRS + 0x09) = 0x10;			// w񐔊ݐ
	*(ADC612ADRS + 0x08) = 0x80;			// gK[h b7:gK(\tggK)
	*(ADC612ADRS + 0x0a) = 0x02;			// TvO~ 
	*(ADC612ADRS + 0x0a) = 0x03;			// TvO 
}

//============================================
// ADϊf[^8chǂݏo 
// 荞ݏ
void intr_adc_pro(void)
{
	int ch;
	
	adc_stus = *(ADC612ADRS + 0x0c); 
	for(ch = 0; ch <= 7; ch++)				// Ǐo
	{
		ad_data[ch] = *(ADC612ADRS + 0x00) << 8;	// 
		ad_data[ch] |= *(ADC612ADRS + 0x00);	// 
	}
	*(ADC612ADRS + 0x0c) = 0xff;			// tONA
}

// ===========================================
// {[h(n[hEFA)ZbgID擾
int adm612_init(							// ID擾 ADM-612PC104 = 0x23
	unsigned long ba)						// LFCQ1 PC/104 8bit I/OGA 擪AhX
{
	int c;
	unsigned char id;						// ID
	
	ADC612ADRS = (unsigned char *)(ba + ADC612OFFS);	// x[XAhXύXł悤ɂ
	
	for(c = 0; c <= 7; c++)
	{
		ad_data[c] = 0;						// ϊf[^NA
	}
	
	id = *(ADC612ADRS + 0x0f);				// {[hZbgID擾
	*(ADC612ADRS + 0x00) = 7;				// `l XLŏIԍ
	*(ADC612ADRS + 0x02) = 0x12;			// f[^\ b4:ʂAb1:2̕␔
	*(ADC612ADRS + 0x03) = 0x00;			// NbN 
	adm612_setprs((ADMINTCLK * 8) / 1000);	// NbN `lƃTvOg(100KHz100000)
	adm612_setcunt(0x00000001);				// TvO񐔐ݒ ([h͖̎)
//	*(ADC612ADRS + 0x06) = 0;				// gKx1
//	*(ADC612ADRS + 0x07) = 0;				// gKx2
//	*(ADC612ADRS + 0x08) = 0x80;			// gK[h b7:gK(\tggK)
//	*(ADC612ADRS + 0x09) = 0x40;			// ݐ
//	*(ADC612ADRS + 0x0a) = 0x02;			// TvO bit1:񐔓
	
	adm612_once();							// _~[ϊ
	
	return id;
}

